Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Static Public Member Functions

# MovieVideoCursor Class Reference

A MovieVideo is actually any source that provides a sequence of video frames. More...

Inheritance diagram for MovieVideoCursor:

List of all members.

## Classes
class | Buffer
## Public Member Functions
bool | aborted ()
| Returns true if the video has aborted prematurely.
| applyToTexture (Buffer const buffer, Texture t, int page)
| Stores this buffer's contents in the indicated texture.
| applyToTextureAlpha (Buffer const buffer, Texture t, int page, int alpha_src)
| Copies this buffer's contents into the alpha channel of the supplied texture.
| applyToTextureRgb (Buffer const buffer, Texture t, int page)
| Copies this buffer's contents into the RGB channels of the supplied texture.
bool | canSeek ()
| Returns true if the movie can seek.
bool | canSeekFast ()
| Returns true if seek operations are constant time.
Buffer | fetchBuffer ()
| Gets the current video frame (as specified by set_time()) from the movie and returns it in a pre-allocated buffer.
int | getNumComponents ()
| Returns 4 if the movie has an alpha channel, 3 otherwise.
MovieVideo | getSource ()
| Get the MovieVideo which this cursor references.
double | length ()
| Returns the length of the movie.
bool | ready ()
| Returns true if the cursor is a streaming source, and if a video frame is ready to be read.
bool | setTime (double timestamp, int loop_count)
| Updates the cursor to the indicated time.
| setupTexture (Texture tex)
| Set up the specified Texture object to contain content from this movie.
int | sizeX ()
| Get the horizontal size of the movie.
int | sizeY ()
| Get the vertical size of the movie.
bool | streaming ()
| Returns true if the video frames are being "pushed" at us by something that operates at its own speed - for example, a webcam.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

A MovieVideo is actually any source that provides a sequence of video frames.

That could include an AVI file, a digital camera, or an internet TV station. A MovieVideoCursor is a handle that lets you read data sequentially from a MovieVideo.

Thread safety: each individual MovieVideoCursor must be owned and accessed by a single thread. It is OK for two different threads to open the same file at the same time, as long as they use separate MovieVideoCursor objects.

## Member Function Documentation

bool aborted | ( |  | ) |

Returns true if the video has aborted prematurely.

For example, this could occur if the Movie was actually an internet TV station, and the connection was lost. Reaching the normal end of the video does not constitute an 'abort' condition.

applyToTexture | ( | Buffer const | buffer,
|  | Texture | t,
|  | int | page
| ) |  |

Stores this buffer's contents in the indicated texture.

applyToTextureAlpha | ( | Buffer const | buffer,
|  | Texture | t,
|  | int | page,
|  | int | alpha_src
| ) |  |

Copies this buffer's contents into the alpha channel of the supplied texture.

The RGB channels of the texture are not touched.

applyToTextureRgb | ( | Buffer const | buffer,
|  | Texture | t,
|  | int | page
| ) |  |

Copies this buffer's contents into the RGB channels of the supplied texture.

The alpha channel of the texture is not touched.

bool canSeek | ( |  | ) |

Returns true if the movie can seek.

If this is true, seeking is still not guaranteed to be fast: for some movies, seeking is implemented by rewinding to the beginning and then fast-forwarding to the desired location. Even if the movie cannot seek, the fetch methods can still advance to an arbitrary location by reading frames and discarding them. However, to move backward, can_seek must return true.

bool canSeekFast | ( |  | ) |

Returns true if seek operations are constant time.

Buffer fetchBuffer | ( |  | ) |

Gets the current video frame (as specified by set_time()) from the movie and returns it in a pre-allocated buffer.

You may simply let the buffer dereference and delete itself when you are done with it.

This may return NULL (even if set_time() returned true) if the frame is not available for some reason.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TypedWritableReferenceCount.

Reimplemented in FfmpegVideoCursor, and InkblotVideoCursor.

int getNumComponents | ( |  | ) |

Returns 4 if the movie has an alpha channel, 3 otherwise.

MovieVideo getSource | ( |  | ) |

Get the MovieVideo which this cursor references.

double length | ( |  | ) |

Returns the length of the movie.

Some kinds of Movie, such as internet TV station, might not have a predictable length. In that case, the length will be set to a very large number: 1.0E10. If the internet TV station goes offline, the video or audio stream will set its abort flag. Reaching the end of the movie (ie, the specified length) normally does not cause the abort flag to be set.

The video and audio streams produced by get_video and get_audio are always of unlimited duration - you can always read another video frame or another audio sample. This is true even if the specified length is reached, or an abort is flagged. If either stream runs out of data, it will synthesize blank video frames and silent audio samples as necessary to satisfy read requests.

Some AVI files have incorrect length values encoded into them - usually, they're a second or two long or short. When playing such an AVI using the Movie class, you may see a slightly truncated video, or a slightly elongated video (padded with black frames). There are utilities out there to fix the length values in AVI files.

bool ready | ( |  | ) |

Returns true if the cursor is a streaming source, and if a video frame is ready to be read.

For non- streaming sources, this is always false.

bool setTime | ( | double | timestamp,
|  | int | loop_count
| ) |  |

Updates the cursor to the indicated time.

If loop_count >= 1, the time is clamped to the movie's length * loop_count. If loop_count <= 0, the time is understood to be modulo the movie's length.

Returns true if a new frame is now available, false otherwise. If this returns true, you should immediately follow this with exactly *one* call to fetch_buffer().

If the movie reports that it can_seek, you may also specify a time value less than the previous value you passed to set_time(). Otherwise, you may only specify a time value greater than or equal to the previous value.

If the movie reports that it can_seek, it doesn't mean that it can do so quickly. It may have to rewind the movie and then fast forward to the desired location. Only if can_seek_fast returns true can it seek rapidly.

setupTexture | ( | Texture | tex | ) |

Set up the specified Texture object to contain content from this movie.

This should be called once, not every frame.

int sizeX | ( |  | ) |

Get the horizontal size of the movie.

int sizeY | ( |  | ) |

Get the vertical size of the movie.

bool streaming | ( |  | ) |

Returns true if the video frames are being "pushed" at us by something that operates at its own speed - for example, a webcam.

In this case, the frames come when they're ready to come. Attempting to read too soon will produce nothing, reading too late will cause frames to be dropped. In this case, the ready flag can be used to determine whether or not a frame is ready for reading.

When streaming, you should still pay attention to last_start, but the value of next_start is only a guess.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties